#Include 'Protheus.ch'

#Define ENTER Chr(13)+Chr(10)
/*
Funcao      : AMDProceda
Objetivos   : Funo para abertura de filtro do proceda.
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 17/07/2012
*/
*-----------------------*       
User Function AMDProceda()
*-----------------------*
Local bOk       := {||lOk:=.T.,oDlg:End()}
Local bCancel   := {||lOk:=.F.,oDlg:End()}
Local lOk       := .F.
Local nLin      := 20
Local nCol1     := 15
Local nCol2     := nCol1+50
Local cMsg      := ""
Local cEmpFil   := GetMv("MV_EMPPROC")
Local oDlg
Local oArqCfg
Local oNFIni
Local oSerIni
Local oNFFim
Local oSerFim


Private cArqCfg := Space(8) //arquivo de configurao (gerado pelo cnab modelo 2, deve seguir o padro no fim desse fonte)
Private cDir    := GetMv("MV_DIREXP1")
Private cFile   := ""
Private nTamNf  := TamSX3("F2_DOC")[1]
Private nTamSer := TamSX3("F2_SERIE")[1]
Private cNFIni  := Space(nTamNf)
Private cSerIni := Space(nTamSer)
Private cNFFim  := Space(nTamNf)
Private cSerFim := Space(nTamSer)
Private nSeq    := 1 //variavel utilizada pela funo "incrementa()"
Private cFilSF2 := xFilial("SF2")
Private cFilSD2 := xFilial("SD2")
Private cFilSZ8 := xFilial("SZ8")
Private cFilSA1 := xFilial("SA1")
Private cFilSA2 := xFilial("SA2")
Private cFilSB1 := xFilial("SB1")

SF2->(dbSetOrder(1))
SD2->(dbSetOrder(3))
SZ8->(dbSetOrder(6))
SA1->(dbSetOrder(1))
SA2->(dbSetOrder(1))
SB1->(dbSetOrder(1))

If !(SM0->(M0_CODIGO+M0_CODFIL) $ cEmpFil)
   MsgAlert("Empresa/Filial no autorizada!")
   Return
EndIf


Define MsDialog oDlg Title 'Gerar arquivo Proceda' From 7,10 To 20,50 OF oMainWnd         
   *   
   @ nLin,nCol1  Say      'Arq. de Config.:'                                               Of oDlg Pixel  
   @ nLin,nCol2  MsGet    oArqCfg Var cArqCfg  Valid ValCpo("CFG")               Size 60,09 Of oDlg Pixel  
   *
   nLin += 15
   *
   @ nLin,nCol1  Say      'Nota Fiscal de:'                                                 Of oDlg Pixel  
   @ nLin,nCol2  MsGet    oNfIni  Var cNfIni   Valid ValCpo("NFINI") F3 "SF2AMD" Size 60,09 Of oDlg Pixel  
   *
   nLin += 15
   *
   @ nLin,nCol1  Say      'Srie de:'                                                       Of oDlg Pixel  
   @ nLin,nCol2  MsGet    oSerIni  Var cSerIni Valid ValCpo("SERINI")            Size 60,09 Of oDlg Pixel  
   *
   nLin += 15
   *
   @ nLin,nCol1  Say      'Nota Fiscal at:'                                                Of oDlg Pixel  
   @ nLin,nCol2  MsGet    oNfFim  Var cNfFim   Valid ValCpo("NFFIM") F3 "SF2AMD" Size 60,09 Of oDlg Pixel  
   *
   nLin += 15
   *
   @ nLin,nCol1  Say      'Srie at:'                                                      Of oDlg Pixel  
   @ nLin,nCol2  MsGet    oSerFim  Var cSerFim Valid ValCpo("SERFIM")            Size 60,09 Of oDlg Pixel  
   *
Activate MsDialog oDlg On Init Enchoicebar(oDlg,bOk,bCancel) Centered

If lOk 
   cMsg := validaCpos()
   If Empty(cMsg) 
      Processa({|| BrowseSF2()}, "Carregando registros")
   Else
      MsgStop(cMSg)
      Return
   EndIf
EndIf
//
Return


/*
Funcao      : BrowseSF2
Objetivos   : Funo da tela de abertura do browse com os dados filtrados da SF2
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 31/08/2012
*/
*-------------------------*
Static Function BrowseSF2()
*-------------------------*
Private cMarca    := GetMark()
Private cCadastro := "Gerao Arquivos Proceda"
Private cArqLog   := "LogProceda.txt"
Private cArqTRB   := ""
Private aRotina   := {{"Gerar Txt","U_TxtProce",0,6}}   
Private aCampos   := {}
Private oMark

aAdd(aCampos, {"F2_MARCA","",""         })
aAdd(aCampos, {"F2_DOC"  ,"","Documento"})
aAdd(aCampos, {"F2_SERIE","","Srie"    })

If !CriaWork()
   MsgAlert("No foi possvel criar o arquivo de trabalho!")
   Return
EndIf
cArqCfg := AllTrim(cArqCfg)+".2RE"
MarkBrow("TRB","F2_MARCA",,aCampos,,cMarca,"U_MkTudo()",,,,"U_Mk()",,,,,,,,.F.) 


MsErase(cArqTRB)//apaga arquivo de trabalho temporrio

Return

/*
Funcao      : CriaWork
Objetivos   : CriaWork de trabalho e popula com os dados da Query
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 31/08/2012
*/
*-------------------------*
Static Function CriaWork()
*-------------------------*
Local cQry := ""
Local aStruct := {}

cQry += " SELECT SF2.F2_DOC, SF2.F2_SERIE "
cQry += " FROM "+RetSqlName("SF2")+" SF2 "
cQry += " WHERE SF2.D_E_L_E_T_ <> '*' "
cQry += " AND SF2.F2_FILIAL = '"+cFilSF2+"' "
cQry += " AND SF2.F2_DOC >= '"+PadL(cNfIni,nTamNf)+"' AND  SF2.F2_DOC <= '"+PadL(cNfFim,nTamNf)+"' "
cQry += " AND SF2.F2_SERIE >= '"+PadL(cSerIni,nTamSer)+"' AND SF2.F2_SERIE <= '"+PadL(cSerIni,nTamSer)+"' "
cQry += " AND SF2.F2_X_PROCE <> '1'"
PlsQuery(cQry,"QRY")

aAdd(aStruct,{"F2_MARCA"  ,"C"                  ,2                    ,0})
aAdd(aStruct,{"F2_DOC"    ,AvSx3("F2_DOC",2)    ,AvSx3("F2_DOC",3)    ,0})
aAdd(aStruct,{"F2_SERIE"  ,AvSx3("F2_SERIE",2)  ,AvSx3("F2_SERIE",3)  ,0})

cArqTRB := CriaTrab(aStruct,.T.)   
If !Used()
   Return .F.
EndIf 
USE &cArqTRB ALIAS "TRB" NEW
IndRegua("TRB",cArqTRB+OrdBagExt(),"F2_DOC")

While QRY->(!Eof())
   RecLock("TRB",.T.)
   AvReplace("QRY","TRB")
   TRB->F2_MARCA := Space(2)
   TRB->(MsUnlock())
   QRY->(dbSkip())
EndDo
QRY->(dbCloseArea())
//
Return .T.  

/*
Funcao      : Mk
Objetivos   : Marca/Desmarca o registro com o duplo clique
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 31/08/2012
*/
*------------------*
User Function Mk()
*------------------*
If IsMark('F2_MARCA',cMarca)        
   RecLock('TRB',.F.)                
   Replace F2_MARCA With Space(2)        
   MsUnLock()
Else        
   RecLock('TRB',.F.)                
   Replace F2_MARCA With cMarca
   MsUnLock()
EndIf
//
Return 

/*
Funcao      : MkTudo
Objetivos   : Marca/Desmarca todos registros
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 31/08/2012
*/
*---------------------*
User Function MkTudo()   
*---------------------*
Local cMarkAux := cMarca
oMark :=  GetMarkBrow()
TRB->(dbGotop())
If IsMark("F2_MARCA",cMarca)
   cMarkAux := Space(2)
EndIf
While TRB->(!Eof()) 
   RecLock("TRB",.F.)
   TRB->F2_MARCA := cMarkAux
   TRB->(MsUnlock())
   TRB->(dbSkip())
End
MarkBRefresh()
oMark:oBrowse:GoTop()
//
Return


/*
Funcao      : TxtProce
Objetivos   : Gera os arquivos TXT das notas marcadas no browse
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 31/08/2012
*/
*----------------------*
User Function TxtProce()
*----------------------*
Private aErros   := {}

TRB->(dbGoTop())
While TRB->(!Eof())
   If TRB->F2_MARCA == cMarca
      //chama funo para gerao do txt.
      Processa({||Proceda()},"Gerando arquivo da nota "+TRB->(F2_DOC+"-"+F2_SERIE))
   EndIf
   TRB->(dbSkip())
EndDo

TRB->(dbGoTop())
While TRB->(!Eof())
   If TRB->F2_MARCA == cMarca .AND. (aScan(aErros,{|x| x[1]+x[2]==TRB->(F2_DOC+F2_SERIE) }))==0
      RecLock("TRB",.F.)
      TRB->(dbDelete())
      TRB->(MsUnlock())
   EndIf
   TRB->(dbSkip())
EndDo

If Len(aErros)>0 //no foi possivel gerar algum arquivo.
   MsgAlert("Ocorreram erros durante a gerao de um ou mais arquivos"+ENTER+;
            "Verifique o arquivo "+cDir+cArqLog)
Else
   MsgInfo("Os arquivos foram gerados corretamente no diretrio:"+ENTER+cDir)
EndIf
oMark :=  GetMarkBrow()
MarkBRefresh()
oMark:oBrowse:GoTop()
//
Return


/*
Funcao      : Proceda
Objetivos   : Funo para leitura de arquivo de 
			  configurao do Proceda (Pela rotina de Cnab modelo 2) e
			  gerao do arquivo para envio.
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 16/07/2012
*/
*-----------------------*
Static Function Proceda()
*-----------------------*
Local nHldCfg  := 0  //verificador de abertura de arquivo
Local nHldNew  := 0  //handle do arquivo gerado
Local nContLin := 1  //conta linha do cabealho que est sendo lido para reposicionamento na troca de cabealho
Local nIni     := 1  //variavel onde ser armazenada a posio inicial do campo 
Local nFim     := 1  //variavel onde ser armazenada a posio final do campo
Local nPosAux  := 1  //variavel para trabalhar com o array de itens auxiliar
Local cBuffer  := "" //buffer do arquivo de configurao lido
Local cSeek    := "" //variavel auxiliar para busca dos detalhes da seo
Local cSecao   := "" //Varivel utilizada para verificar o .T./.F. da seo
Local cLinha   := "" //linha corrente do novo txt que est sendo criada
Local cAcao    := "" //ao configurada para o campo atual no arquivo .2re
Local xDado          //Varivel dinmica que receber o dado a ser adicionado no arquivo criado
Local aAuxItem := {} //array auxiliar para montar os itens
Local lFornec  := .F.//varivel que diz se ir buscar as informaes do cliente ou do fornecedor

//Posiciona a SF2 antes de qualquer coisa
SF2->(dbSeek(cFilSF2+TRB->(F2_DOC+F2_SERIE)))
If SF2->F2_TIPO $ "B/D"
   SA2->(dbSeek(cFilSA2+SF2->(F2_CLIENTE+F2_LOJA)))
   lFornec := .T.
Else
   SA1->(dbSeek(cFilSA1+SF2->(F2_CLIENTE+F2_LOJA)))
EndIf
SZ8->(dbSeek(cFilSZ8+TRB->(F2_DOC+F2_SERIE)+SF2->(F2_CLIENTE+F2_LOJA)+SM0->(M0_CODIGO+M0_CODFIL)))


cFile := SM0->(M0_CODIGO+M0_CODFIL)+AllTrim(TRB->(F2_DOC+Left(F2_SERIE,2)))+".txt"

nHldCfg := Ft_FUse(cArqCfg)
If nHldCfg <> -1
   nHldNew := FCreate(AllTrim(cDir+cFile))
   If nHldNew == -1
      SalvaLog("No foi possvel criar o arquivo de saida "+AllTrim(cDir+cFile))
      aAdd(aErros,{TRB->F2_DOC,TRB->F2_SERIE})
      Return
   EndIf
   Ft_FGoTop()
   cBuffer := Ft_FReadLn()
   While !Ft_FEof() .And. SubStr(cBuffer,1,1)=="1"
      cSecao := SubStr(cBuffer,35,3)
      //Se estiver como .F. no pega seo
      If !&cSecao
         nContLin++
         Ft_FSkip()
         cBuffer := Ft_FReadLn()
         Loop
      EndIf
      //pega linha de cabealho e busca no arquivo
      cSeek := SubStr(cBuffer,2,3)
      While !Ft_FEof() .And. SubStr(cBuffer,1,4)!="2"+cSeek
         Ft_FSkip()
         cBuffer := Ft_FReadLn()
      EndDo
      cLinha := ""                        
      
      //Loop em todos os registros da chave (cSeek) para montar linha
      While !Ft_FEof() .And. SubStr(cBuffer,1,4)=="2"+cSeek
         nIni := Val(SubStr(cBuffer,20,3))
         nFim := Val(SubStr(cBuffer,23,3))
         If lFornec
            cBuffer := StrTran(cBuffer,"A1","A2")
         EndIf
         Do Case
            //Seo tipo "000"
            Case SubStr(cBuffer,1,4)=="20D0"        
               
               cAcao := AllTrim(SubStr(cBuffer,27,Len(cBuffer)-26))
               xDado := &cAcao
               cLinha += CharFormat(xDado,nIni,nFim)               
               
               
            //Seo tipo "310"
            Case SubStr(cBuffer,1,4)=="20D1"        
               
               cAcao := AllTrim(SubStr(cBuffer,27,Len(cBuffer)-26))
               xDado := &cAcao
               cLinha += CharFormat(xDado,nIni,nFim)               
               
               
            //Seo tipo "311"
            Case SubStr(cBuffer,1,4)=="20D2"
               
               cAcao := AllTrim(SubStr(cBuffer,27,Len(cBuffer)-26))
               xDado := &cAcao
               cLinha += CharFormat(xDado,nIni,nFim)               
               
               
            //Seo tipo "312"
            Case SubStr(cBuffer,1,4)=="20D3"
               
               cAcao := AllTrim(SubStr(cBuffer,27,Len(cBuffer)-26))
               xDado := &cAcao
               cLinha += CharFormat(xDado,nIni,nFim)               
               
               
            //Seo tipo "313"
            Case SubStr(cBuffer,1,4)=="20D4"

               cAcao := AllTrim(SubStr(cBuffer,27,Len(cBuffer)-26))
               xDado := &cAcao
               cLinha += CharFormat(xDado,nIni,nFim)
           
           
            //Seo tipo "314"
            Case SubStr(cBuffer,1,4)=="20D5"
               nPosAux := 1
               SD2->(dbSeek(cFilSD2+TRB->(F2_DOC+F2_SERIE)))
               While SD2->(!Eof()) .And. cFilSD2+TRB->(F2_DOC+F2_SERIE) == SD2->(D2_FILIAL+D2_DOC+D2_SERIE)
                  SB1->(dbSeek(cFilSB1+SD2->D2_COD))
                  cAcao := AllTrim(SubStr(cBuffer,27,Len(cBuffer)-26))
                  xDado := &cAcao
                  If nIni = 1
                     aAdd(aAuxItem, CharFormat(xDado,nIni,nFim))
                  Else
                     aAuxItem[nPosAux] += CharFormat(xDado,nIni,nFim)               
                  EndIf
                  nPosAux++
                  SD2->(dbSkip())
               EndDo
           
           
            //Seo tipo "315"
            Case SubStr(cBuffer,1,4)=="20D6"
               
               cAcao := AllTrim(SubStr(cBuffer,27,Len(cBuffer)-26))
               xDado := &cAcao
               cLinha += CharFormat(xDado,nIni,nFim)               
               
               
            //Seo tipo "316"
            Case SubStr(cBuffer,1,4)=="20D7"
               
               cAcao := AllTrim(SubStr(cBuffer,27,Len(cBuffer)-26))
               xDado := &cAcao
               cLinha += CharFormat(xDado,nIni,nFim)               
               
               
            //Seo tipo "317"
            Case SubStr(cBuffer,1,4)=="20D8"
               
               cAcao := AllTrim(SubStr(cBuffer,27,Len(cBuffer)-26))
               xDado := &cAcao
               cLinha += CharFormat(xDado,nIni,nFim)               
               
               
            //Seo tipo "318"
            Case SubStr(cBuffer,1,4)=="20D9"
               
               cAcao := AllTrim(SubStr(cBuffer,27,Len(cBuffer)-26))
               xDado := &cAcao
               cLinha += CharFormat(xDado,nIni,nFim)               
               
               
            //Seo tipo "319"
            Case SubStr(cBuffer,1,4)=="21D0"
               
               cAcao := AllTrim(SubStr(cBuffer,27,Len(cBuffer)-26))
               xDado := &cAcao
               cLinha += CharFormat(xDado,nIni,nFim)               
               
               
         EndCase
         Ft_FSkip()
         cBuffer := Ft_FReadLn()
      EndDo
      //adiciona a linha no arquivo
      If nContLin == 6 //prxima seo depois dos itens
         For i:=1 To Len(aAuxItem)
            aAuxItem[i] += ENTER
            FWrite(nHldNew, aAuxItem[i])
         Next i
         aAuxItem := {}
      Else
         cLinha += ENTER
         FWrite(nHldNew,cLinha)
      EndIf  
      //Volta para a linha que estava antes da busca do detalhe
      Ft_FGoTop()
      For i:=1 To nContLin
         Ft_FSkip()
      Next i
      nContLin++
      cBuffer := Ft_FReadLn()
   EndDo
Else
   SalvaLog("No foi possvel abrir o arquivo de configurao "+cArqCfg)
   aAdd(aErros,{TRB->F2_DOC,TRB->F2_SERIE})
   FClose(nHldNew)
   Return
EndIf
Ft_FUse()
FClose(nHldNew)
RecLock("SF2",.F.)
SF2->F2_X_PROCE := "1"
SF2->(MsUnlock())
//
Return


/*
Funcao      : CharFormat
Objetivos   : Formata a string passada para o tamanho configurado no arquivo
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 17/07/2012
*/
*---------------------------------------*
Static Function CharFormat(cChar,nIni,nFim)
*---------------------------------------*
Local   nLen  := 0
Default cChar := ""
Default nIni  := 0
Default nFim  := 0
//
If (nIni== 0 .And. nFim==0) .Or. nFim<nIni
   Return ""
Else 
   nLen := (nFim+1)-nIni
EndIf
//verifica o tipo de dado, caso seja deferente de Char converte o mesmo.
If ValType(cChar) != "C"
   cChar := AllToChar(cChar)
EndIf
//
If Len(cChar)>nLen
   cChar := SubStr(cChar,1,nLen)
Else
   cChar := PadR(cChar,nLen)
EndIf                               
//
Return cChar

/*
Funcao      : AllToChar
Objetivos   : Converte varivel passada para caracter
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 17/07/2012
*/
*------------------------------------------*
Static Function AllToChar(xVarInfo,cPicture)
*------------------------------------------*
Local   cVar     := ""
Local   cVarType := ValType(xVarInfo)  
Default cPicture := ""
    
Do Case
   Case (cVarType=="N")
      cPicture := "@ER "+Replicate("9",Len(AllTrim(Str(xVarInfo))))
      cVar := Transform(xVarInfo,cPicture)
   Case (cVarType=="C")
      If !Empty(cPicture)
         cVar := Transform(xVarInfo, AllTrim(cPicture))
      Else
         cVar := xVarInfo
      EndIf
   Case (cVarType=="L")
      cVar := If(xVarInfo,".T.",".F.")
   Case (cVarType=="D")
      IIf(Empty(cPicture),cPicture:="5",)
      cVar := GravaData(xVarInfo,.F.,Val(cPicture))
EndCase

Return cVar


/*
Funcao      : RetPictVal
Objetivos   : Retorna a picture do valor passado.
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 17/07/2012
*/
*---------------------------------------*
Static Function RetPictVal(nVal,lDecZero)
*---------------------------------------*
Local   cPict       := ""
Local   cPictSepMil := ""
Local   uInt
Local   uDec
Local   lPictSepMil := .F.
Default lDecZero    := .F.

If (ValType(nVal) == "N")
   uInt := Int(nVal)
   uDec := (nVal-uInt)
   If ((uDec==0) .And. !lDecZero)
      uDec := Nil
   EndIf
   If (uDec!=Nil)
      uDec := AllTrim(Str(uDec))
      uDec := SubStr(uDec, At(".",uDec)+1)
      uDec := Len(uDec)
   EndIf
   uInt  := Len(AllTrim(Str(uInt)))
   nInt  := uInt
   cPict := Replicate("9",uInt)

   If(lPictSepMil)
      If (nInt>3)
         cPictSepMil := cPict
         cPict := ""
         For uInt := nInt To 1 Step - 3
            cPict := (","+SubStr(cPictSepMil,-3,uInt)+cPict)
            Next uInt
      EndIf
   EndIf
   If(uDec<>NIL)
      cPict += "."
      cPict += Replicate("9",uDec)
      nDec  := uDec
   EndIf
EndIf

Return cPict

/*
Funcao      : validaCpos
Objetivos   : Faz a validao dos campos da tela de filtro
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 17/07/2012
*/
*-------------------------*
Static Function validaCpos()
*-------------------------*
Local cMsg := ""

If Empty(cArqCfg)
   cMsg += "Campo Arquivo deve ser preenchido!"+ENTER
ElseIf !File(AllTrim(cArqCfg)+".2RE")
   cMsg += "Arquivo de Configurao selecionado no existe!"+ENTER   
EndIf                            

If Empty(cNfFim)
   cMsg += 'Campo "Nota Fiscal at" deve ser preenchido!'+ENTER
EndIf

If Empty(cSerFim)
   cMsg += 'Campo Srie "at" deve ser preenchido!'
EndIf

Return cMsg

/*
Funcao      : ValCpo
Objetivos   : Faz a validao do campo de filtro passado
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 17/07/2012
*/
*-------------------------*
Static Function ValCpo(cCpo)
*-------------------------*
lRet := .T.
//
Do Case 
   Case cCpo == "CFG"
      If Empty(cArqCfg)
         MsgAlert("O campo arquivo deve ser preenchido!")
         lRet := .F.
      ElseIf !File(AllTrim(cArqCfg)+".2RE")
         MsgAlert("O arquivo informado no existe!")
         lRet := .F.
      EndIf
   Case cCpo == "NFINI"
      If !Empty(cNfIni) .AND. !SF2->(dbSeek(cFilSF2+cNfini))
         MsgAlert("Nota fiscal informada no existe!")
         lRet := .F.
      EndIf
   Case cCpo == "SERINI"
      If !Empty(cSerIni) .AND. !SF2->(dbSeek(cFilSF2+cNfIni+cSerIni))
         MsgAlert("A srie informada no pertence a nota selecionada!")
         lRet := .F.
      EndIf
   Case cCpo == "NFFIM"
      If SF2->(dbSeek(cFilSF2+cNfFim))
         cSerFim := SF2->F2_SERIE
      ElseIf Upper(cNfFim) $ "ZZZZZZ"
         cSerFim := "ZZZ"
      Else
         MsgAlert("Nota fiscal informada invlida!")
         lRet := .F.
      EndIf
   Case cCpo == "SERFIM"
      If !Upper(cSerFim) $ "ZZZ" .AND. !SF2->(dbSeek(cFilSF2+cNfFim+cSerFim))
         MsgAlert("A srie informada no pertence a nota selecionada!")
         lRet := .F.
      EndIf
EndCase
//
Return lRet

/*
Funcao      : SalvaLog
Objetivos   : Salva arquivo de log com os dados que no foram gerados
Autor       : Kanam L. R. Rodrigues 
Data/Hora   : 31/08/2012
*/
*------------------------------*
Static Function SalvaLog(cMsg)
*------------------------------*
local nCod      := 0 
Local nTamArq   := 0

If !File(cDir+cArqLog)
   nCod := FCreate(cDir+cArqLog)
Else
   nCod := FOpen(cDir+cArqLog,2)
EndIf                        

//verifica se abriu o arquivo
If nCod == -1
   Return
EndIf

//Define o tamanho do arquivo
nTamArq := FSeek(nCod,0,2) 
//manda o ponteiro para o fim do arquivo
FSeek(nCod,nTamArq) 
FWrite(nCod,DTOC(dDataBase)+" - "+Time()+" - "+TRB->F2_DOC+"-"+TRB->F2_SERIE+ENTER)
FWrite(nCod,cMsg)
FWrite(nCod,ENTER+ENTER)
FClose(nCod)
//
Return



/*
O arquivo gerado pelo modelo 2 do cnab deve seguir a seguinte sequencia de registros.

0D0 - SEO 000 DO ARQUIVO MODELO PROCEDA
0D1 - SEO 310 DO ARQUIVO MODELO PROCEDA
0D2 - SEO 311 DO ARQUIVO MODELO PROCEDA
0D3 - SEO 312 DO ARQUIVO MODELO PROCEDA
0D4 - SEO 313 DO ARQUIVO MODELO PROCEDA
0D5 - SEO 314 DO ARQUIVO MODELO PROCEDA
0D6 - SEO 315 DO ARQUIVO MODELO PROCEDA
0D7 - SEO 316 DO ARQUIVO MODELO PROCEDA
0D8 - SEO 317 DO ARQUIVO MODELO PROCEDA
0D9 - SEO 318 DO ARQUIVO MODELO PROCEDA
1D0 - SEO 319 DO ARQUIVO MODELO PROCEDA
*/